> For the complete documentation index, see [llms.txt](https://docs.flatredball.com/flatredball/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.flatredball.com/flatredball/glue-reference/enable-live-edit/render-targets.md).

# Render Targets

At the time of this writing if you are rendering to a render target that is of different size than your game, then you may see that either:

* Your game may not occup the entire screen
* Interacting with objects in your game may not align properly

You can solve this by disabling render targets in your game. For example, your draw code may look something like this:

```csharp
// make the engine draw to the buffer
GraphicsDevice.SetRenderTarget(buffer);

GeneratedDrawEarly(gameTime);
FlatRedBallServices.Draw();
GeneratedDraw(gameTime);

// reset the render target to null
GraphicsDevice.SetRenderTarget(null);

// draw the buffer to the screen
spriteBatch.Begin(SpriteSortMode.Immediate, BlendState.AlphaBlend);
var destinationRectangle = new Rectangle(0, 0, buffer.Width, buffer.Height);
spriteBatch.Draw(buffer, destinationRectangle, Color.White);
spriteBatch.End();

base.Draw(gameTime);
```

You can optionally render to a render target if not in edit mode. For example, after you change your code it might look like this:

```csharp
if(!ScreenManager.IsInEditMode)
{
    // make the engine draw to the buffer
    GraphicsDevice.SetRenderTarget(buffer);
}

GeneratedDrawEarly(gameTime);
FlatRedBallServices.Draw();
GeneratedDraw(gameTime);

if(!ScreenManager.IsInEditMode)
{
    // reset the render target to null
    GraphicsDevice.SetRenderTarget(null);

    // draw the buffer to the screen
    spriteBatch.Begin(SpriteSortMode.Immediate, BlendState.AlphaBlend);
    //spriteBatch.Begin(SpriteSortMode.Immediate, BlendState.AlphaBlend, effect: activeEffect);
    var destinationRectangle = new Rectangle(0, 0, buffer.Width, buffer.Height);
    spriteBatch.Draw(buffer, destinationRectangle, Color.White);
    spriteBatch.End();
}

base.Draw(gameTime);
```

Note that future versions of FlatRedBall may provide options for handling render target scaling with the cursor, but as of the time of this writing this is not yet supported.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.flatredball.com/flatredball/glue-reference/enable-live-edit/render-targets.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
